package com.github.huangp.learning.ga.travellingsalemanproblem;

import com.google.common.base.Objects;

/**
 * @author Patrick Huang
 *         <a href="mailto:pahuang@redhat.com">pahuang@redhat.com</a>
 */
public class City {
    private int x;
    private int y;

    public City(int x, int y) {
        this.x = x;
        this.y = y;
    }
    public City() {
        x = (int) (Math.random() * 200);
        y = (int) (Math.random() * 200);
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public double distance(City other) {
        int xDistance = x - other.x;
        int yDistance = y - other.y;
        return Math.sqrt(xDistance * xDistance + yDistance * yDistance);
    }

    @Override
    public String toString() {
        return String.format("(%d, %d)", x, y);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        City city = (City) o;

        return Objects.equal(x, city.x) && Objects.equal(y, city.y);
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(x, y);
    }
}
