package com.github.huangp.learning.sorting;



public class MergeSort {
    private int[] src;
    private int[] copy;

    public void sort(int[] nums) {
        src = nums;
        copy = new int[nums.length];
        mergeSort(0, src.length - 1);
    }

    private void mergeSort(int low, int high) {
        if (low >= high) {
            return;
        }
        int mid = low + (high - low) / 2;
        mergeSort(low, mid);
        mergeSort(mid + 1, high);
        merge(low, mid, high);
    }

    private void merge(int low, int mid, int high) {
        int left = low; // left side start index
        int right = mid + 1; // right side start index
        int index = low;
        for(int i = low; i <= high; i++) {
            copy[i] = src[i];
        }
        while(left <= mid && right <= high) {
            int leftValue = copy[left];
            int rightValue = copy[right];
            if (leftValue < rightValue) {
                src[index] = leftValue;
                left++;
            } else {
                src[index] = rightValue;
                right++;
            }
            index++;
        }
        // copy left over from left side
        for(; left <= mid; left++, index++) {
            src[index] = copy[left];
        }
    }

}
