package com.github.huangp.learning.sorting;

import java.util.Arrays;

/**
 * @author Patrick Huang
 *         <a href="mailto:pahuang@redhat.com">pahuang@redhat.com</a>
 */
public class QuickSort {
    public void sort(int[] nums) {
        System.out.println(Arrays.toString(nums));
        System.out.println("=====================");
        quickSort(nums, 0, nums.length - 1);
    }

    private void quickSort(int[] nums, int low, int high) {
        if (low >= high) {
            return;
        }
        int pivotFinalIndex = partition(nums, low, high);
        quickSort(nums, low, pivotFinalIndex - 1);
        quickSort(nums, pivotFinalIndex + 1, high);
    }

    private int partition(int[] nums, int low, int high) {
        int pivot = low + (high - low) / 2;
        int cur = low;
        int pivotValue = nums[pivot];
        System.out.println("pivot: " + pivot + " value: " + pivotValue);
        // put pivot at the end of the array
        swap(nums, pivot, high);
        System.out.println(Arrays.toString(nums));
        // from left to right
        for(int i = low; i < high; i++) {
            // when a value is smaller then pivot value, we swap it with current index(which will be a value greater than pivot value)
            if (nums[i] <= pivotValue) {
                if (cur != i) {
                    swap(nums, cur, i);
                    System.out.println("* " + Arrays.toString(nums));
                }
                cur++;
            }
        }
        swap(nums, cur, high); // swap back pivot value to its final place
        System.out.println(Arrays.toString(nums));
        return cur;
    }

    private static void swap(int[] nums, int left, int right) {
        int tmp = nums[left];
        nums[left] = nums[right];
        nums[right] = tmp;
    }
}
