package com.github.huangp.learning.ga.travellingsalemanproblem;

import org.junit.Before;
import org.junit.Test;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class TravellingSalesmanGATest {

    private TravellingSalesmanGA algorithm = new TravellingSalesmanGA(0.015, 10);
    private DestinationCities destinationCities = DestinationCities.manager();

    @Before
    public void setUp() {
        // Create and add our cities
        City city = new City(60, 200);
        destinationCities.addCity(city);
        City city2 = new City(180, 200);
        destinationCities.addCity(city2);
        City city3 = new City(80, 180);
        destinationCities.addCity(city3);
        City city4 = new City(140, 180);
        destinationCities.addCity(city4);
        City city5 = new City(20, 160);
        destinationCities.addCity(city5);
        City city6 = new City(100, 160);
        destinationCities.addCity(city6);
        City city7 = new City(200, 160);
        destinationCities.addCity(city7);
        City city8 = new City(140, 140);
        destinationCities.addCity(city8);
        City city9 = new City(40, 120);
        destinationCities.addCity(city9);
        City city10 = new City(100, 120);
        destinationCities.addCity(city10);
        City city11 = new City(180, 100);
        destinationCities.addCity(city11);
        City city12 = new City(60, 80);
        destinationCities.addCity(city12);
        City city13 = new City(120, 80);
        destinationCities.addCity(city13);
        City city14 = new City(180, 60);
        destinationCities.addCity(city14);
        City city15 = new City(20, 40);
        destinationCities.addCity(city15);
        City city16 = new City(100, 40);
        destinationCities.addCity(city16);
        City city17 = new City(200, 40);
        destinationCities.addCity(city17);
        City city18 = new City(20, 20);
        destinationCities.addCity(city18);
        City city19 = new City(60, 20);
        destinationCities.addCity(city19);
        City city20 = new City(160, 20);
        destinationCities.addCity(city20);
    }

    @Test
    public void findBestRout() {
        PopulationOfTours firstGeneration = PopulationOfTours.firstGeneration(50);
        log.debug("initial route: {}", firstGeneration.getFittest());

        log.info("initial distance: {}", firstGeneration.getFittest().totalTravellingDistance());
        PopulationOfTours nextGeneration = algorithm.evolvePopulation(firstGeneration);

        // evolve 100 generations
        int numOfGenerations = 100;
        for (int i = 1; i < numOfGenerations; i++) {
//            log.debug("next gen route: {}", nextGeneration.getFittest());
            log.info("generation {} distance: {}", i, nextGeneration.getFittest().totalTravellingDistance());
            nextGeneration = algorithm.evolvePopulation(nextGeneration);
        }

        CandidateTour lastGenFittest = nextGeneration.getFittest();
        log.info("final distance: {}", lastGenFittest.totalTravellingDistance());
        log.info("route to take: {}", lastGenFittest);
    }

}