package com.github.huangp.learning.sorting;

import org.junit.Test;

import static org.assertj.core.api.Assertions.assertThat;

/**
 * @author Patrick Huang
 *         <a href="mailto:pahuang@redhat.com">pahuang@redhat.com</a>
 */
public class QuickSortTest {
    private QuickSort sort = new QuickSort();

    @Test
    public void canSort() {
        int[] result = { 2, 3, 4, 1, 7, 9, 5 };
        sort.sort(result);
        assertThat(result).containsExactly(1, 2, 3, 4, 5, 7, 9);
    }

    @Test
    public void canSortSingle() {
        int[] result = { 1 };
        sort.sort(result);
        assertThat(result).containsExactly(1);
    }

    @Test
    public void canHandleDuplicateValues() {
        int[] result = { 3, 2, 2, 1 };
        sort.sort(result);
        assertThat(result).containsExactly(1, 2, 2, 3);
    }

    @Test
    public void test() {
        System.out.println(Integer.parseInt("a", 16) + "");
        System.out.println(Integer.parseInt("b", 16) + "");
        System.out.println(Integer.parseInt("c", 16) + "");
        System.out.println(Integer.parseInt("e", 16) + "");
        System.out.println(Integer.parseInt("d", 16) + "");
        System.out.println(" " + ((int) "g".toCharArray()[0]));
        System.out.println(" " + ((int) "a".toCharArray()[0]));
    }
}
